"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StatusBar = void 0;
const vscode_1 = require("vscode");
class StatusBar {
    item;
    _status = "ready";
    constructor() {
        this.item = vscode_1.window.createStatusBarItem(vscode_1.StatusBarAlignment.Right);
        this.ready();
        this.show();
    }
    status() {
        return this._status;
    }
    show() {
        this.item.show();
    }
    dispose() {
        this.item.dispose();
    }
    ready() {
        this._status = "ready";
        this.item.command = "cherry-studio-recorder.start";
        this.item.text = "$(debug-start) Cherry Studio";
    }
    running() {
        this._status = "running";
        this.item.command = "cherry-studio-recorder.stop";
        this.item.text = "$(debug-stop) Recording";
    }
    starting() {
        this._status = "starting";
        this.item.command = undefined;
        this.item.text = "$(loading~spin) Preparing...";
    }
    stopping() {
        this._status = "stopping";
        this.item.command = undefined;
        this.item.text = "$(sync~spin) Processing...";
    }
}
exports.StatusBar = StatusBar;
//# sourceMappingURL=statusBar.js.map