"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Zipper = void 0;
const vscode = __importStar(require("vscode"));
const minimatch_1 = require("minimatch");
const JSZip = require("jszip");
class Zipper {
    ignoredPaths;
    constructor(config) {
        this.ignoredPaths = config.ignoredPaths;
    }
    async addFolderToZip(rootFolder, folderUri, zip, folderInZip = zip) {
        let filePathList = [];
        const folderEntries = await vscode.workspace.fs.readDirectory(folderUri);
        for (const [name, type] of folderEntries) {
            const entryUri = vscode.Uri.joinPath(folderUri, name);
            const relativePath = entryUri.path.replace(rootFolder.path + '/', '');
            if (this.ignoredPaths.some(ignoredPath => (0, minimatch_1.minimatch)(relativePath, ignoredPath))) {
                continue;
            }
            if (type === vscode.FileType.Directory) {
                const folderZip = folderInZip.folder(name);
                if (folderZip) {
                    filePathList = filePathList.concat(await this.addFolderToZip(rootFolder, entryUri, zip, folderZip));
                }
            }
            else if (type === vscode.FileType.File) {
                const fileContent = await vscode.workspace.fs.readFile(entryUri);
                folderInZip.file(name, fileContent);
                filePathList.push(entryUri.path);
            }
        }
        return filePathList;
    }
    async zipFolder(dir) {
        const zip = new JSZip();
        const filePathList = await this.addFolderToZip(dir, dir, zip);
        return [filePathList, await zip.generateAsync({ type: 'uint8array' })];
    }
}
exports.Zipper = Zipper;
//# sourceMappingURL=zipper.js.map